package org.sadigit.adapter;

import jakarta.json.bind.adapter.JsonbAdapter;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.io.ParseException;
import org.locationtech.jts.io.WKTReader;
import org.locationtech.jts.io.WKTWriter;

@SuppressWarnings("unused")
public class GeometryAdapter implements JsonbAdapter<Geometry, String> {

    private static final int DEFAULT_SRID = 4326; // Default SRID

    @Override
    public String adaptToJson(Geometry geometry) throws Exception {
        if (geometry == null) {
            return null;
        }
        WKTWriter writer = new WKTWriter();
        return writer.write(geometry);
    }

    @Override
    public Geometry adaptFromJson(String json) throws Exception {
        if (json == null || json.isEmpty()) {
            return null;
        }
        WKTReader reader = new WKTReader();
        try {
            return reader.read(json);
        } catch (ParseException e) {
            throw new IllegalArgumentException("Invalid WKT string: " + json, e);
        }
    }
}