package org.sadigit.boundary.v2.endpoint;

import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import org.sadigit.model.ResponseModelIntegKeluhanMobile;
import org.sadigit.model.ResponseModelIntegKeluhanMobileTanpaOutData;

import io.smallrye.mutiny.Uni;
import jakarta.inject.Inject;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.QueryParam;
import jakarta.ws.rs.core.Response;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Path("/api/apkt/integkeluhanmobile")
@Produces("application/json")
public class IntegKeluhanMobileResourceV2 {

    @POST
    @Path("/P018_SETPENJELASANBIDANGV2")
    public Response P018_SETPENJELASANBIDANGV2(
            @QueryParam(value = "IN_REPORTNUMBER") String IN_REPORTNUMBER,
            @QueryParam(value = "IN_USER") String IN_USER,
            @QueryParam(value = "IN_CUSTOMERRESPONSE") String IN_CUSTOMERRESPONSE,
            @QueryParam(value = "IN_REMARK") String IN_REMARK,
            @QueryParam(value = "IN_IMPLEMENTOR") String IN_IMPLEMENTOR,
            @QueryParam(value = "IN_ISSUETYPE") String IN_ISSUETYPE,
            @QueryParam(value = "IN_SUBISSUETYPE") String IN_SUBISSUETYPE) {

        ResponseModelIntegKeluhanMobileTanpaOutData mapResponse = new ResponseModelIntegKeluhanMobileTanpaOutData();
        Map<String, Object> mapResult;
        Map<String, Object> mapParam = new HashMap<>();

        try {
            mapParam.put("IN_REPORTNUMBER", IN_REPORTNUMBER);
            mapParam.put("IN_USER", IN_USER);
            mapParam.put("IN_CUSTOMERRESPONSE", IN_CUSTOMERRESPONSE);
            mapParam.put("IN_REMARK", IN_REMARK);
            mapParam.put("IN_IMPLEMENTOR", IN_IMPLEMENTOR);
            mapParam.put("IN_ISSUETYPE", IN_ISSUETYPE);
            mapParam.put("IN_SUBISSUETYPE", IN_SUBISSUETYPE);

            mapParam.put("OUT_RC", "VARCHAR");
            mapParam.put("OUT_MESSAGE", "VARCHAR");
            mapParam.put("OUT_DATA", "CURSOR");

            // mapResult = IntegKeluhanMobileService.P20_SETPENJELASANBIDANG(mapParam);
            // mapResponse =
            // AppServerIntegKeluhanMobileLoginTanpaOutData.setResultMessage(mapResult);
            // System.out.println(" log = " + mapResponse);

        } catch (Exception e) {
            // log.error(e.getMessage(), e);
            mapResponse.setMessage(e.getMessage());
            // mapResponse.setRc("06");
        }

        return Response.ok(mapResponse).build();

    }

    @POST
    @Path("/P21_MUTASI_KG")
    public Response P21_MUTASI_KG(
            @QueryParam(value = "IN_REPORTNUMBER") String IN_REPORTNUMBER,
            @QueryParam(value = "IN_USER") String IN_USER,
            @QueryParam(value = "IN_ALASAN") String IN_ALASAN) {

        ResponseModelIntegKeluhanMobileTanpaOutData mapResponse = new ResponseModelIntegKeluhanMobileTanpaOutData();
        Map<String, Object> mapResult;
        Map<String, Object> mapParam = new HashMap<>();

        try {
            mapParam.put("IN_REPORTNUMBER", IN_REPORTNUMBER);
            mapParam.put("IN_USER", IN_USER);
            mapParam.put("IN_ALASAN", IN_ALASAN);

            mapParam.put("OUT_RC", "VARCHAR");
            mapParam.put("OUT_MESSAGE", "VARCHAR");
            // mapParam.put("OUT_DATA", "CURSOR");

            // mapResult = IntegKeluhanMobileService.P21_MUTASI_KG(mapParam);
            // mapResponse =
            // AppServerIntegKeluhanMobileLoginTanpaOutData.setResultMessage(mapResult);
            // System.out.println(" log = " + mapResponse);

        } catch (Exception e) {
            // log.error(e.getMessage(), e);
            mapResponse.setMessage(e.getMessage());
            // mapResponse.setRc("06");
        }

        return Response.ok(mapResponse).build();

    }

    @POST
    @Path("/P22_SEND_LISTRIQU")
    public Response P22_SEND_LISTRIQU(
            @QueryParam(value = "IN_REPORTNUMBER") String IN_REPORTNUMBER,
            @QueryParam(value = "IN_USER") String IN_USER,
            @QueryParam(value = "IN_ALASAN") String IN_ALASAN) {

        ResponseModelIntegKeluhanMobileTanpaOutData mapResponse = new ResponseModelIntegKeluhanMobileTanpaOutData();
        Map<String, Object> mapResult;
        Map<String, Object> mapParam = new HashMap<>();

        try {
            mapParam.put("IN_REPORTNUMBER", IN_REPORTNUMBER);
            mapParam.put("IN_USER", IN_USER);
            mapParam.put("IN_ALASAN", IN_ALASAN);

            mapParam.put("OUT_RC", "VARCHAR");
            mapParam.put("OUT_MESSAGE", "VARCHAR");
            // mapParam.put("OUT_DATA", "CURSOR");

            // mapResult = IntegKeluhanMobileService.P21_MUTASI_KG(mapParam);
            // mapResponse =
            // AppServerIntegKeluhanMobileLoginTanpaOutData.setResultMessage(mapResult);
            // System.out.println(" log = " + mapResponse);

        } catch (Exception e) {
            // log.error(e.getMessage(), e);
            mapResponse.setMessage(e.getMessage());
            // mapResponse.setRc("06");
        }

        return Response.ok(mapResponse).build();

    }

}
