package org.sadigit.control.errorhandler;

import java.util.LinkedHashMap;
import java.util.Map;

import org.sadigit.control.exception.BadRequestBodyException;

import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;

@Provider
public class BadRequestBodyErrorHandler implements ExceptionMapper<BadRequestBodyException> {

    @Override
    public Response toResponse(BadRequestBodyException exception) {
        Map<String, Object> response = new LinkedHashMap<>();
        response.put("status", false);
        response.put("title", "Bad Request");
        response.put("message", exception.getMessage());

        return Response.status(403).entity(response).build();
    }

}
