package org.sadigit.control.errorhandler;

import java.util.LinkedHashMap;
import java.util.Map;

import org.sadigit.control.exception.FileProcessingException;

import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;

@Provider
public class FileProcessingErrorHandler implements ExceptionMapper<FileProcessingException> {

    @Override
    public Response toResponse(FileProcessingException exception) {

        Map<String, Object> response = new LinkedHashMap<>();
        response.put("status", false);
        response.put("title", "Bad Request");
        response.put("message", exception.getMessage());

        return Response.status(403).entity(response).build();
    }

}
