package org.sadigit.entity;

import lombok.Getter;
import lombok.Setter;

import java.sql.Timestamp;
import java.util.List;

import org.hibernate.annotations.Immutable;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;

@Entity
@Getter
@Setter
@Immutable
@Table(name = "appuser", schema = "apkt_transactional")
public class AppUser extends PanacheEntityBase {

    @Id
    @Column(name = "userid", nullable = false)
    private Long userId;

    @Column(name = "username", length = 200)
    private String username;

    @Column(name = "employeename", length = 200)
    private String employeeName;

    @Column(name = "nip", length = 200)
    private String nip;

    @Column(name = "password", length = 200)
    private String password;

    @Column(name = "address", length = 4000)
    private String address;

    @Column(name = "phone", length = 20)
    private String phone;

    @Column(name = "mobile", length = 20)
    private String mobile;

    @Column(name = "email", length = 200)
    private String email;

    @Column(name = "positionid")
    private Long positionId;

    @Column(name = "unitid")
    private Long unitId;

    @Column(name = "isactive", length = 255)
    private String isActive;

    @Column(name = "islogin", length = 255)
    private String isLogin;

    @Column(name = "passwordchangedate")
    private Timestamp passwordChangeDate;

    @Column(name = "createdate")
    private Timestamp createDate;

    @Column(name = "createby")
    private Long createBy;

    @Column(name = "updatedate")
    private Timestamp updateDate;

    @Column(name = "updateby")
    private Long updateBy;

    @Column(name = "pukid")
    private Long pukId;

    @Column(name = "pukanswer", length = 200)
    private String pukAnswer;

    @Column(name = "defaulttab")
    private Long defaultTab;

    @Column(name = "no_imei", length = 50)
    private String noImei;

    @Column(name = "domain", length = 50)
    private String domain;

    @Column(name = "picture")
    private String picture;

    @OneToMany(mappedBy = "idUser")
    private List<UserRole> userRole;

}
