package org.sadigit.entity;

import java.math.BigDecimal;
import java.security.Timestamp;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Getter
@Setter
@Table(name = "unit", schema = "apkt_transactional")
public class Unit {
    @Id
    @Column(name = "unitid", nullable = false)
    private Long unitId;

    @Column(name = "unitcode", length = 10)
    private String unitCode;

    @Column(name = "unitname", length = 100)
    private String unitName;

    @Column(name = "unittypeid")
    private Long unitTypeId;

    @Column(name = "unitparent")
    private Long unitParent;

    @Column(name = "address", length = 250)
    private String address;

    @Column(name = "city", length = 50)
    private String city;

    @Column(name = "zip", length = 5)
    private String zip;

    @Column(name = "phone", length = 20)
    private String phone;

    @Column(name = "mobile", length = 20)
    private String mobile;

    @Column(name = "fax", length = 20)
    private String fax;

    @Column(name = "email", length = 100)
    private String email;

    @Column(name = "ipaddress", length = 15)
    private String ipAddress;

    @Column(name = "createdate")
    private Timestamp createDate;

    @Column(name = "createby")
    private BigDecimal createBy;

    @Column(name = "updatedate")
    private Timestamp updateDate;

    @Column(name = "updateby")
    private BigDecimal updateBy;

    @Column(name = "isactive", length = 1)
    private String isActive;

    @Column(name = "coordinator")
    private BigDecimal coordinator;

    @Column(name = "supervisor")
    private BigDecimal supervisor;

    @Column(name = "assistantmanager")
    private BigDecimal assistantManager;

    @Column(name = "assmanphone", length = 20)
    private String assManPhone;

    @Column(name = "vehiclecolor", length = 10)
    private String vehicleColor;
}
