package org.sadigit.mapper;

import org.sadigit.entity.AppUser;
import org.sadigit.model.dto.PenggunaDto;
import org.sadigit.util.Checks;

import io.quarkus.logging.Log;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class PenggunaMapper {
    public PenggunaMapper() {
    }

    public static PenggunaDto entityToDTO(AppUser entity) {

        return PenggunaDto.builder()
                .nip(entity.getNip())
                .positionid(entity.getPositionId().intValue())
                .roleid(getFirstRoleId(entity))
                .unitid(entity.getUnitId().intValue())
                .userid(entity.getUserId().intValue())
                .employeename(entity.getEmployeeName())
                .username(entity.getUsername())
                .build();
    }

    private static Integer getFirstRoleId(AppUser entity) {
        if (entity.getUserRole() != null && !entity.getUserRole().isEmpty()) {
            return entity.getUserRole().get(0).getIdRole().intValue();
        }
        return null;
    }

}