package org.sadigit.repository;

import java.util.List;

import org.sadigit.entity.AppUser;

import io.quarkus.hibernate.orm.panache.PanacheRepositoryBase;
import jakarta.enterprise.context.ApplicationScoped;

@ApplicationScoped
public class AppUserRepository implements PanacheRepositoryBase<AppUser, Long> {
    public AppUser findByUsername(String username) {
        return find("username", username).count() > 0 ? find("username", username).firstResult() : null;
    }

    public AppUser findByUsernameAndPassword(String username, String password) {
        return find("username = ?1 and password = ?2", username, password).firstResult();
    }

    public List<AppUser> findByUnitIdAndPositionId(Long unitId, Long positionId) {
        return find("unitId = ?1 and positionId = ?2 and isActive='1'", unitId, positionId).list();
    }
}
