package org.sadigit.repository;

import java.sql.Date;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

import org.sadigit.entity.Keluhan;

import io.quarkus.hibernate.orm.panache.PanacheRepositoryBase;
import jakarta.enterprise.context.ApplicationScoped;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class KeluhanRepository implements PanacheRepositoryBase<Keluhan, Long> {
    public List<Keluhan> findKeluhanByUnitId(Long unitId, String startDate, String endDate) {

        Date start = Date.valueOf(startDate);
        Date end = Date.valueOf(endDate);

        log.info("start: {}", start);

        return find("unit = ?1 and date(createdDate) >= ?2 and date(createdDate)<= ?3", unitId, start, end)
                .list();
    }
}
