package org.sadigit.repository;

import java.util.List;

import org.hibernate.Session;
import org.hibernate.query.Query;
import org.sadigit.model.dto.UnitDto;

import io.quarkus.hibernate.orm.panache.PanacheRepositoryBase;

import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;

@ApplicationScoped
public class UnitRepository implements PanacheRepositoryBase<UnitDto, Long> {
    @Inject
    Session session;

    public List<UnitDto> findByUnitTypeId(Long unitTypeId) {
        Query<UnitDto> query = session.createQuery(
                "SELECT (SELECT B.unitName FROM Unit B WHERE B.unitId = A.unitParent) AS unitJaringan, A.unitName, A.unitId, A.unitTypeId, A.unitParent "
                        + "FROM Unit A WHERE unitTypeId = ?1",
                UnitDto.class);
        query.setParameter(1, unitTypeId);
        return query.list();
    }
}
