package org.sadigit.service.api.v1;

import java.util.List;
import java.util.stream.Collectors;

import org.sadigit.entity.Keluhan;
import org.sadigit.mapper.KeluhanMapper;
import org.sadigit.mapper.PenggunaMapper;
import org.sadigit.model.dto.KeluhantDto;
import org.sadigit.repository.KeluhanRepository;

import jakarta.enterprise.context.ApplicationScoped;
import lombok.RequiredArgsConstructor;

@ApplicationScoped
@RequiredArgsConstructor
public class GetDataPerUnitService {
    private final KeluhanRepository keluhanRepository;

    public List<KeluhantDto> getDataPerUnit(Long unitId, String startDate, String endDate) {
        return keluhanRepository.findKeluhanByUnitId(unitId, startDate, endDate).stream()
                .map(KeluhanMapper::entityToDTO)
                .collect(Collectors.toList());
    }
}
