package org.sadigit.service.api.v1;

import java.util.List;
import java.util.stream.Collectors;

import org.sadigit.mapper.IssueTypeMapper;
import org.sadigit.mapper.MasterIssueTypeMapper;
import org.sadigit.model.dto.IssueTypeDto;
import org.sadigit.model.dto.MasterIssueTypeDto;
import org.sadigit.repository.IssueTypeRepository;

import jakarta.enterprise.context.ApplicationScoped;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

@ApplicationScoped
@RequiredArgsConstructor
@Slf4j
public class IssueTypeService {
    private final IssueTypeRepository issueTypeRepository;

    public List<MasterIssueTypeDto> findAll() {
        return issueTypeRepository.findIssueTypeKeluhan().stream().map(MasterIssueTypeMapper::entityToDTO)
                .collect(Collectors.toList());
    }

    public List<IssueTypeDto> findActive() {
        return issueTypeRepository.findIssueTypeActiveKeluhan().stream().map(IssueTypeMapper::entityToDTO)
                .collect(Collectors.toList());
    }
}
