package org.sadigit.service.api.v1;

import java.util.List;

import org.sadigit.entity.AppUser;
import org.sadigit.mapper.AppUserMapper;
import org.sadigit.model.dto.AppUserDto;
import org.sadigit.repository.AppUserRepository;
import org.sadigit.util.Checks;

import jakarta.enterprise.context.ApplicationScoped;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

@ApplicationScoped
@RequiredArgsConstructor
@Slf4j
public class LoginService {
    private final AppUserRepository appUserRepository;

    AppUserDto appUser;

    public List<AppUserDto> auth(String username, String password) {
        log.info("auth password : {}", password);
        // find appuser by username
        Checks.isTrues(appUserRepository.findByUsername(username) != null,
                "DATA TIDAK DITEMUKAN / USER SUDAH TIDAK ACTIVE", "1");

        // find user by username and password
        appUser = AppUserMapper.entityToDTO(appUserRepository.findByUsernameAndPassword(username, password));

        Checks.isTrues(appUser != null, "PASSWORD TIDAK SESUAI", "99");

        return List.of(appUser);

    }
}
