package org.sadigit.service.api.v1;

import java.util.List;
import java.util.stream.Collectors;

import org.sadigit.entity.AppUser;
import org.sadigit.mapper.AppUserMapper;
import org.sadigit.mapper.PenggunaMapper;
import org.sadigit.model.dto.AppUserDto;
import org.sadigit.model.dto.PenggunaDto;
import org.sadigit.repository.AppUserRepository;
import org.sadigit.util.Checks;

import jakarta.enterprise.context.ApplicationScoped;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

@ApplicationScoped
@RequiredArgsConstructor
@Slf4j
public class PenggunaService {
    private final AppUserRepository appUserRepository;

    PenggunaDto pengguna;

    public List<PenggunaDto> findDataPengguna(Long unitId, Long positionId) {
        Checks.isTrues(appUserRepository.findByUnitIdAndPositionId(unitId, positionId) != null,
                "DATA TIDAK DITEMUKAN", "1");

        return appUserRepository.findByUnitIdAndPositionId(unitId, positionId).stream().map(PenggunaMapper::entityToDTO)
                .collect(Collectors.toList());

    }
}
