package org.sadigit.util.validator;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import org.sadigit.util.validator.impl.ValidDateFormatValidator;

import jakarta.validation.Constraint;
import jakarta.validation.Payload;

/**
 * Annotation for checking if String is in correct date format (yyyy-MM-dd HH:mm:ss)
 *
 * @author Tias Mardiansyah
 *
 */
@Retention(java.lang.annotation.RetentionPolicy.RUNTIME)
@Target({
        ElementType.FIELD,
})
@Constraint(validatedBy = ValidDateFormatValidator.class)
public @interface ValidDateFormat {
    String message() default "Format tanggal harus mengikuti format berikut (yyyy-MM-dd HH:mm:ss)";

    Class<? extends Payload>[] payload() default {};

    Class<?>[] groups() default {};
}
