package org.sadigit.util.validator.impl;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import org.sadigit.util.validator.ValidDateFormat;

import jakarta.validation.ConstraintValidator;
import jakarta.validation.ConstraintValidatorContext;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class ValidDateFormatValidator implements ConstraintValidator<ValidDateFormat, String> {

    @Override
    public boolean isValid(String value, ConstraintValidatorContext context) {
        
        try {
            DateTimeFormatter inputFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
            LocalDateTime.parse(value, inputFormatter);
        } catch (Exception e) {
            log.error("error parsing, reason : {}", e.getMessage());
            context.buildConstraintViolationWithTemplate("Terjadi kesalahan dalam format tanggal, pastikan format tanggal sesuai (yyyy-MM-dd HH:mm:ss)")
            .addConstraintViolation();
            return false;
        }
        
        return true;
        
    }
    
}
